var express = require('express'), path = require('path'), http = require('http'), fx = require('./lib/fx'), btc = require('./lib/btc'), train = require('./lib/train')
    //train = require('lib/train')
/* ,submit = require('./routes/mongo/submit') */
    ;
var app = express();
GLOBAL.lastcheck = 0;
var btcCache = {}, fxCache = {} , trainCache = {};

app.configure(function () {
    app.set('port', process.env.PORT || 4545);
    app.use(express.logger('dev'));
    app.use(express.cookieParser());
    app.use(express.session({secret: '1234567890QWERTY'}));
    /* 'default', 'short', 'tiny', 'dev' */
    app.use(express.methodOverride());

    app.use(express.bodyParser());

    app.use(function (req, res, next) {
        res.header("Access-Control-Allow-Origin", "*");
        res.header("Access-Control-Allow-Headers", "X-Requested-With");
        next();
    });
    app.use(app.router);
    app.use(express.static(path.join(__dirname, 'app')));
    app.use(express.errorHandler({dumpExceptions: true, showStack: true}));

    app.use('/btc', btc.doBTC);

    app.use('/fx', fx.doFx);

    app.use('/dbeglq', train.dbe_glq);

    app.use('/glqdbe', train.glq_dbe);
    app.use('/gettrains', train.getTrainTimes);

    app.use('/lot', function (req, res) {
        var pg = require('pg');

        var conString = "postgres://pguser:1V3D4m526i@localhost/silver";
        console.log(conString);


        var client = new pg.Client(conString);
        var q = 'select * from lot order by d desc';
        client.connect(function(err) {
            if(err) {
                return console.error('could not connect to postgres', err);
            }
            client.query(q, function(err, result) {
                if(err) {
                    return console.error('error running query', err);
                }
                console.log(result.rows[0].theTime);
                //output: Tue Jan 15 2013 19:12:47 GMT-600 (CST)
                client.end();
            });
        });
    });
});

/**
 * create the server
 */
http.createServer(app).listen(app.get('port'), function () {
    console.log("Express server listening on port " + app.get('port'));
});
